'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _fetchWithRetries = require('fbjs/lib/fetchWithRetries');

var _fetchWithRetries2 = _interopRequireDefault(_fetchWithRetries);

var _getHeaders = require('./getHeaders');

var _getHeaders2 = _interopRequireDefault(_getHeaders);

var _getRequestBody = require('./getRequestBody');

var _getRequestBody2 = _interopRequireDefault(_getRequestBody);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Link = function Link(props) {
  var _this = this;

  (0, _classCallCheck3.default)(this, Link);

  this.fetch = function () {
    var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(request, variables, cacheConfig, uploadables) {
      var headers, body, response, contentType;
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              headers = (0, _extends3.default)({}, (0, _getHeaders2.default)(uploadables), _this.headers);
              body = (0, _getRequestBody2.default)(request, variables, uploadables);
              _context.next = 4;
              return (0, _fetchWithRetries2.default)(_this.url, {
                method: 'POST',
                fetchTimeout: _this.fetchTimeout,
                retryDelays: _this.retryDelays,
                headers: headers,
                body: body
              });

            case 4:
              response = _context.sent;
              contentType = response.headers.get('content-type');

              if (!(contentType && contentType.indexOf('application/json') !== -1)) {
                _context.next = 8;
                break;
              }

              return _context.abrupt('return', response.json());

            case 8:
              return _context.abrupt('return', response.text());

            case 9:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, _this);
    }));

    return function (_x, _x2, _x3, _x4) {
      return _ref.apply(this, arguments);
    };
  }();

  (0, _invariant2.default)(props, 'Fetch: missing props');
  (0, _invariant2.default)(props.url, 'Fetch: missing "url"');

  this.url = props.url;
  this.headers = props.headers || {};
  this.fetchTimeout = props.fetchTimeout || 30000;
  this.retryDelays = props.retryDelays || [1000, 3000, 5000, 10000];
};

exports.default = Link;