'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getRequestBodyWithUploadables = function getRequestBodyWithUploadables(request, variables, uploadables) {
  var formData = new FormData();
  formData.append('query', request.text);
  formData.append('variables', (0, _stringify2.default)(variables));

  uploadables.forEach(function (uploadable, key) {
    // $FlowIgnore
    formData.append('image' + key, {
      name: uploadable.filename || 'image' + key + '.jpg',
      type: uploadable.mime || 'image/jpg',
      uri: uploadable.path
    });
  });

  return formData;
};


var getRequestBodyWithoutUplodables = function getRequestBodyWithoutUplodables(request, variables) {
  return (0, _stringify2.default)({
    query: request.text,
    variables: variables
  });
};

var getRequestBody = function getRequestBody(request, variables, uploadables) {
  if (uploadables) {
    return getRequestBodyWithUploadables(request, variables, uploadables);
  }

  return getRequestBodyWithoutUplodables(request, variables);
};

exports.default = getRequestBody;